unit uDetallesMedicacionController;

interface

uses
  uDADataTable, uBizDetallesMedicacion, uIDataModuleMedicacion, uControllerDetallesArticulos,
  uBizArticulos, uBizContactos;

type
  IDetallesMedicacionController = interface(IControllerDetallesArticulos)
  ['{38B4EE57-A247-4A41-A62C-CC18B8793FB3}']
    procedure AnadirArticulos(ADetalles: IDAStronglyTypedDataTable; const ANuevaFila :Boolean = True; const ACantidad: Integer = 1); overload;
    procedure ActualizarDetalles(ADetalles: IDAStronglyTypedDataTable); overload;
  end;

  TDetallesMedicacionController = class(TControllerDetallesArticulos, IDetallesMedicacionController)
  private
    FDataModule : IDataModuleMedicacion;
  protected
    procedure AsignarController; override;
    //Si sobreescribimos este método podremos tener en cuenta otras columnas para el calculo del importe total de un concepto
    function CalcularImporteTotalConcepto(DataTable: TDADataTable): Double; override;
    procedure ValidarCampos(DataTable: TDADataTable); override;
  public
    procedure AnadirArticulos(ADetalles: IDAStronglyTypedDataTable; const ANuevaFila :Boolean = True; const ACantidad: Integer = 1); overload;
    procedure ActualizarDetalles(ADetalles: IDAStronglyTypedDataTable); overload;
    constructor Create; override;
    destructor Destroy; override;
  end;

implementation

uses
  Dialogs, uDialogUtils, Variants, uControllerDetallesBase,
  uCalculosUtils, uDataModuleMedicaciones, uArticulosMedicacionController;

{ TDetallesMedicacionController }

procedure TDetallesMedicacionController.ActualizarDetalles(ADetalles: IDAStronglyTypedDataTable);
var
  AArticulos : IBizArticulo;
begin
  if Assigned(ADetalles) then
  begin
    try
      AArticulos := (FArticulosController.BuscarTodos as IBizArticulo);
      ActualizarDetalles(ADetalles, AArticulos);
//      ShowInfoMessage('Se ha actualizado el descuento para el cliente seleccionado');  Esta desactivado el descuento general para los albaranes de cliente
    finally
      AArticulos := Nil;
    end;
  end;
end;

procedure TDetallesMedicacionController.AnadirArticulos(ADetalles: IDAStronglyTypedDataTable; const ANuevaFila :Boolean; const ACantidad: Integer);
var
  AArticulos: IBizArticulo;
begin
  if Assigned(ADetalles) then
  begin
    try
      AArticulos := (FArticulosController.BuscarTodos as IBizArticulo);

      //Si nueva fila es false, quiere decir que se sustituye un determinado artículo, por ello la lista a seleccionar no debe ser multiselect
      if ANuevaFila then
      begin
        AArticulos := (FArticulosController as IArticulosMedicacionController).ElegirArticulos(AArticulos, 'Elija los artículos que desea añadir a este albarán de cliente', True);
        Add(ADetalles, AArticulos, ACantidad)
      end
      else
      begin
        AArticulos := (FArticulosController as IArticulosMedicacionController).ElegirArticulos(AArticulos, 'Elija el artículo que desea añadir a este albarán de cliente', False);
        RellenarDetalle(ADetalles, AArticulos, ACantidad);
      end;

    finally
      AArticulos := Nil;
    end;
  end;
end;

procedure TDetallesMedicacionController.AsignarController;
begin
  FArticulosController := TArticulosMedicacionController.Create;
end;

{procedure TDetallesMedicacionController.AsignarDatos(ADetalles: IDAStronglyTypedDataTable; IDCabecera: Integer);
begin
  inherited;

  with (ADetalles as IBizDetallesMedicacion) do
  begin
    Edit;
//    ID := FDataModule.GetNextID(DataTable.LogicalName);
    ID_ALBARAN := IDCabecera;
    Post
  end;
end;}

function TDetallesMedicacionController.CalcularImporteTotalConcepto(DataTable: TDADataTable): Double;
begin
  Result := CalcularLineaConcepto(DataTable);
end;

constructor TDetallesMedicacionController.Create;
begin
  inherited;
  FDataModule := TDataModuleMedicacion.Create(Nil);
end;

destructor TDetallesMedicacionController.Destroy;
begin
  FDataModule := Nil;
  inherited;
end;


procedure TDetallesMedicacionController.ValidarCampos(DataTable: TDADataTable);
begin
  inherited;
  ValidarCamposLineaConcepto(DataTable);
end;

end.
